// This file was generated by Dashcode from Apple Inc.
// Copyright 2009-2010 Daniel Pimley

var internal_filesize = 0;
var internal_datarate = 0;
var internal_duration = 0;
var datarate_magnitude = 1000;
var filesize_magnitude = 1024;
var filesize_memory = 0;
var datarate_memory = 0;
var duration_memory = 0;
var disk_info = new Array();
var movie_info = new Array();

Array.prototype.clean = function(deleteValue) {
  for (var i = 0; i < this.length; i++) {
    if (this[i] == deleteValue) {         
      this.splice(i, 1);
      i--;
    }
  }
  return this;
};

// Called by HTML body element's onload event when the widget is ready to start
function load()
{
    setupParts();
	SetupLocalization();
	LoadPreferences();
}

// Called when the widget has been removed from the Dashboard
function remove()
{
	SavePreferences();
}

// Called when the widget has been hidden
function hide()
{
	EraseLocalDisks();
}

// Called when the widget has been shown
function show()
{
	SetupLocalDisks();
}

// Called when the info button is clicked to show the back of the widget
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

// Called when the done button is clicked from the back of the widget
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}

function SetupLocalization()
{
	document.getElementById("popup_duration").object.button.textElement.innerText = getLocalizedString("Duration");
	document.getElementById("popup_duration").object.select.options[0].text = getLocalizedString("Duration");
	document.getElementById("popup_duration").object.select.options[1].text = getLocalizedString("34 minutes");
	document.getElementById("popup_duration").object.select.options[2].text = getLocalizedString("64 minutes");
	document.getElementById("popup_duration").object.select.options[3].text = getLocalizedString("94 minutes");
		
	document.getElementById("popup_size").object.button.textElement.innerText = getLocalizedString("File Size");
	document.getElementById("popup_size").object.select.options[0].text = getLocalizedString("File Size");
	document.getElementById("popup_size").object.select.options[1].text = getLocalizedString("CD-R 18 minutes 158 MB");
	document.getElementById("popup_size").object.select.options[2].text = getLocalizedString("CD-R 21 minutes 185 MB");
	document.getElementById("popup_size").object.select.options[3].text = getLocalizedString("CD-R 63 minutes 550 MB");
	document.getElementById("popup_size").object.select.options[4].text = getLocalizedString("CD-R 74 minutes 650 MB");
	document.getElementById("popup_size").object.select.options[5].text = getLocalizedString("CD-R 80 minutes 700 MB");
	document.getElementById("popup_size").object.select.options[6].text = getLocalizedString("DVD±R 4.7 GB");
	document.getElementById("popup_size").object.select.options[7].text = getLocalizedString("DVD±R 8.5 GB");
	document.getElementById("popup_size").object.select.options[8].text = getLocalizedString("BD-R 25 GB");
	document.getElementById("popup_size").object.select.options[9].text = getLocalizedString("BD-R 50 GB");

	document.getElementById("popup_size_magnitude").object.button.textElement.innerText = getLocalizedString("Binary KiB");
	document.getElementById("popup_size_magnitude").object.select.options[0].text = getLocalizedString("Binary KiB");
	document.getElementById("popup_size_magnitude").object.select.options[1].text = getLocalizedString("Binary MiB");
	document.getElementById("popup_size_magnitude").object.select.options[2].text = getLocalizedString("Binary GiB");
	document.getElementById("popup_size_magnitude").object.select.options[3].text = getLocalizedString("Decimal KB");
	document.getElementById("popup_size_magnitude").object.select.options[4].text = getLocalizedString("Decimal MB");
	document.getElementById("popup_size_magnitude").object.select.options[5].text = getLocalizedString("Decimal GB");
	
	document.getElementById("popup_rate").object.button.textElement.innerText = getLocalizedString("Data Rate");
	document.getElementById("popup_rate").object.select.options[0].text = getLocalizedString("Data Rate");

	document.getElementById("popup_rate_magnitude").object.button.textElement.innerText = getLocalizedString("Kbps");
	document.getElementById("popup_rate_magnitude").object.select.options[0].text = getLocalizedString("Kbps");
	document.getElementById("popup_rate_magnitude").object.select.options[1].text = getLocalizedString("Mbps");
}

function SetupLocalDisks()
{
	try {
		if (window.DiskInfo) {
			disk_info = DiskInfo.getDiskInfo();
            for (var i = 0; i < disk_info[0].length; i++ ) {
                // Filter "net" and "home" from FSVolumeInfo results in Snow Leopard
                if ( !(("home" == disk_info[0][i]) && (0 == disk_info[2][i])) && !(("net" == disk_info[0][i]) && (0 == disk_info[2][i])) ) {
				    document.getElementById("popup_size").object.select.options[document.getElementById("popup_size").object.select.length] = new Option(disk_info[0][i], disk_info[2][i], false);
                }
			}
		}
	} catch(ex) {
		EraseLocalDisks();
	}
}

function EraseLocalDisks()
{
	document.getElementById("popup_size").object.select.length = 10;
	disk_info = new Array();
}

function LoadPreferences()
{
	var load_size_magnitude = widget.preferenceForKey("size_magnitude_value");
	if ( load_size_magnitude != undefined ) {
		load_size_magnitude = parseInt(load_size_magnitude, 10)
		if ( load_size_magnitude == 1024 || load_size_magnitude == 1048576 || load_size_magnitude == 1073741824 ) filesize_magnitude = load_size_magnitude;
		if ( load_size_magnitude == 1000 || load_size_magnitude == 1000000 || load_size_magnitude == 1000000000 ) filesize_magnitude = load_size_magnitude;
		if ( filesize_magnitude == 1024 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(0);
		}
		if ( filesize_magnitude == 1048576 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(1);
		}
		if ( filesize_magnitude == 1073741824 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(2);
		}
		if ( filesize_magnitude == 1000 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(3);
		}
		if ( filesize_magnitude == 1000000 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(4);
		}
		if ( filesize_magnitude == 1000000000 ) {
			document.getElementById("popup_size_magnitude").object.setSelectedIndex(5);
		}
	}

	var load_rate_magnitude = widget.preferenceForKey("rate_magnitude_value");
	if ( load_rate_magnitude != undefined ) {
		load_rate_magnitude = parseInt(load_rate_magnitude, 10)
		if ( load_rate_magnitude == 1000 || load_rate_magnitude == 1000000 ) datarate_magnitude = load_rate_magnitude;
		if ( datarate_magnitude == 1000 ) {
			document.getElementById("popup_rate_magnitude").object.setSelectedIndex(0);
		}
		if ( datarate_magnitude == 1000000 ) {
			document.getElementById("popup_rate_magnitude").object.setSelectedIndex(1);
		}
	}
}

function SavePreferences()
{
	widget.setPreferenceForKey(parseInt(filesize_magnitude, 10), "size_magnitude_value");
	widget.setPreferenceForKey(parseInt(datarate_magnitude, 10), "rate_magnitude_value");
}

function DurationMemoryClear()
{
	duration_memory = 0;
}

function DurationMemoryPlus()
{
	DurationUpdate();
	duration_memory = duration_memory + internal_duration;
}

function DurationMemoryMinus()
{
	DurationUpdate();
	duration_memory = duration_memory - internal_duration;
}

function DurationMemoryRecall()
{
	internal_duration = duration_memory;
	document.getElementById("popup_duration").object.setSelectedIndex(0);
	DurationDisplay();
}

function FileSizeMemoryClear()
{
	filesize_memory = 0;
}

function FileSizeMemoryPlus()
{
	FileSizeUpdate();
	filesize_memory = filesize_memory + internal_filesize;
}

function FileSizeMemoryMinus()
{
	FileSizeUpdate();
	filesize_memory = filesize_memory - internal_filesize;
}

function FileSizeMemoryRecall()
{
	internal_filesize = filesize_memory;
	document.getElementById("popup_size").object.setSelectedIndex(0);
	FileSizeDisplay();
}

function DataRateMemoryClear()
{
	datarate_memory = 0;
}

function DataRateMemoryPlus()
{
	DataRateUpdate();
	datarate_memory = datarate_memory + internal_datarate;
}

function DataRateMemoryMinus()
{
	DataRateUpdate();
	datarate_memory = datarate_memory - internal_datarate;
}

function DataRateMemoryRecall()
{
	internal_datarate = datarate_memory;
	document.getElementById("popup_rate").object.setSelectedIndex(0);
	DataRateDisplay();
}

function DurationChanged()
{
	document.getElementById("popup_duration").object.setSelectedIndex(0);
	DurationUpdate();
}

function FileSizeChanged()
{
	document.getElementById("popup_size").object.setSelectedIndex(0);
	FileSizeUpdate();
}

function DataRateChanged()
{
	document.getElementById("popup_rate").object.setSelectedIndex(0);
	DataRateUpdate();
}

function DurationUpdate()
{
	internal_duration = 0;
	if ( isNaN(document.getElementById("textfield_duration_hh").value) ) {
		document.getElementById("textfield_duration_hh").value = "00";
	} else {
		internal_duration = internal_duration + ( document.getElementById("textfield_duration_hh").value * 3600 );
	}
	if ( isNaN(document.getElementById("textfield_duration_mm").value) ) {
		document.getElementById("textfield_duration_mm").value = "00";
	} else {
		internal_duration = internal_duration + ( document.getElementById("textfield_duration_mm").value * 60 );
	}
	if ( isNaN(document.getElementById("textfield_duration_ss").value) ) {
		document.getElementById("textfield_duration_mm").value = "00";
	} else {
		internal_duration = internal_duration + ( document.getElementById("textfield_duration_ss").value * 1 );
	}
}

function FileSizeUpdate()
{
	internal_filesize = 0;
	if ( isNaN(document.getElementById("textfield_size").value) ) {
		document.getElementById("textfield_size").value = "0";
	} else {
		internal_filesize = document.getElementById("textfield_size").value * filesize_magnitude;
	}
}

function DataRateUpdate()
{
	internal_datarate = 0;
	if ( isNaN(document.getElementById("textfield_rate").value) ) {
		document.getElementById("textfield_rate").value = "0";
	} else {
		internal_datarate = document.getElementById("textfield_rate").value * datarate_magnitude;
	}
}

function DurationDisplay()
{
	var internal_hh = 0;
	var internal_mm = 0;
	var internal_ss = Math.round(internal_duration);
	while ( internal_ss > 3599 ) { internal_ss = ( internal_ss - 3600 ); internal_hh = internal_hh + 1 }
	while ( internal_ss > 59 ) { internal_ss = ( internal_ss - 60 ); internal_mm = internal_mm + 1 }
	internal_hh = LeadingZeros(internal_hh, 2);
	internal_mm = LeadingZeros(internal_mm, 2);
	internal_ss = LeadingZeros(internal_ss, 2);
	document.getElementById("textfield_duration_hh").value = internal_hh;
	document.getElementById("textfield_duration_mm").value = internal_mm;
	document.getElementById("textfield_duration_ss").value = internal_ss;
}

function LeadingZeros(theNumber, max)
{
	var numStr = String(theNumber);
	while ( numStr.length < max) {
		numStr = '0' + numStr;
	}
	return numStr;
}

function FileSizeDisplay()
{
	var theSum = ( internal_filesize / filesize_magnitude ).toFixed(2);
	if ( parseInt(theSum, 10) == theSum ) theSum = parseInt(theSum, 10);
	document.getElementById("textfield_size").value = theSum;
}

function DataRateDisplay()
{
	var theSum = ( internal_datarate / datarate_magnitude ).toFixed(3);
	if ( parseInt(theSum, 10) == theSum ) theSum = parseInt(theSum, 10);
	document.getElementById("textfield_rate").value = theSum;
}

function DurationCalculate()
{
	document.getElementById("popup_duration").object.setSelectedIndex(0);
	DurationUpdate();
	FileSizeUpdate();
	DataRateUpdate();
	if ( ( internal_filesize > 0 ) && ( internal_datarate > 0 ) ) internal_duration = ( internal_filesize / ( internal_datarate / 8 ) );
	DurationDisplay();
	FileSizeDisplay();
	DataRateDisplay();
}

function FileSizeCalculate()
{
	document.getElementById("popup_size").object.setSelectedIndex(0);
	DurationUpdate();
	FileSizeUpdate();
	DataRateUpdate();
	if ( ( internal_duration > 0 ) && ( internal_datarate > 0 ) ) internal_filesize = ( ( internal_datarate / 8 ) * internal_duration );
	DurationDisplay();
	FileSizeDisplay();
	DataRateDisplay();
}

function DataRateCalculate()
{
	document.getElementById("popup_rate").object.setSelectedIndex(0);
	DurationUpdate();
	FileSizeUpdate();
	DataRateUpdate();
	if ( ( internal_duration > 0 ) && ( internal_filesize > 0 ) ) internal_datarate = ( ( internal_filesize * 8 ) / internal_duration );
	DurationDisplay();
	FileSizeDisplay();
	DataRateDisplay();
}

function FileSizeMagnitude()
{
	var popupValue = document.getElementById("popup_size_magnitude");
	filesize_magnitude = popupValue.object.getValue();
	FileSizeDisplay();
}

function DataRateMagnitude()
{
	var popupValue = document.getElementById("popup_rate_magnitude");
	datarate_magnitude = popupValue.object.getValue();
	DataRateDisplay();
}

function DurationPresets()
{
	var popupValue = document.getElementById("popup_duration");
	popupValue = popupValue.object.getValue();
	if ( popupValue != -1 ) internal_duration = popupValue;
	DurationDisplay();
}

function FileSizePresets()
{
	var popupValue = document.getElementById("popup_size");
	popupValue = popupValue.object.getValue();
	if ( popupValue != -1 ) internal_filesize = popupValue;
	FileSizeDisplay();
}

function DataRatePresets()
{
	var popupValue = document.getElementById("popup_rate");
	popupValue = popupValue.object.getValue();
	if ( popupValue != -1 ) internal_datarate = popupValue;
	DataRateDisplay();
}

function TextfieldsFocus(event) {
        event.target.style.color = "rgb(255, 255, 255)";
}

function TextfieldsBlur(event) {
        event.target.style.color = "rgb(255, 0, 0)";
}

function DurationDragDrop(event)
{
	event.stopPropagation();
	event.preventDefault();
	document.getElementById("popup_duration").object.setSelectedIndex(0);
	try {
		var uriString = event.dataTransfer.getData("text/uri-list");
		var uriList = uriString.split("\n");
		if (window.DiskInfo) {
            movie_info = DiskInfo.getMovieInfo(uriList[0]);
            var movie_duration = movie_info[0];
            var movie_timescale = movie_info[2];
            internal_duration = ( movie_duration / movie_timescale );
        }
	} catch(ex) {
		if ( isNaN(internal_duration) ) internal_duration = 0;
	}
	DurationDisplay();
}

function FileSizeDragDrop(event)
{
	event.stopPropagation();
	event.preventDefault();
	document.getElementById("popup_size").object.setSelectedIndex(0);
	try {
		var uriString = event.dataTransfer.getData("text/uri-list");
		var uriList = uriString.split("\n");
		if (window.DiskInfo) {
            movie_info = DiskInfo.getMovieInfo(uriList[0]);
            internal_filesize = movie_info[1];
        }
	} catch(ex) {
		if ( isNaN(internal_filesize) ) internal_filesize = 0;
	}
	FileSizeDisplay();
}

function DataRateDragDrop(event)
{
	event.stopPropagation();
	event.preventDefault();
	document.getElementById("popup_rate").object.setSelectedIndex(0);
	try {
		var uriString = event.dataTransfer.getData("text/uri-list");
		var uriList = uriString.split("\n");
		if (window.DiskInfo) {
            movie_info = DiskInfo.getMovieInfo(uriList[0]);
            var movie_duration = movie_info[0];
            var movie_filesize = movie_info[1];
            var movie_timescale = movie_info[2];
            internal_datarate = ( movie_filesize * 8 ) / ( movie_duration / movie_timescale );
        }
	} catch(ex) {
		if ( isNaN(internal_datarate) ) internal_datarate = 0;
	}
	DataRateDisplay();
}

// Be sure to assign these handlers for the ondragenter and ondragover events on your drop target
// These handlers prevent Web Kit from processing drag events so you can handle the drop when it occurs
function dragEnter(event)
{
	event.stopPropagation();
	event.preventDefault();
}
function dragOver(event)
{
	event.stopPropagation();
	event.preventDefault();
}

function ShowMyHomePage()
{
	widget.openURL("http://www.pimley.net/projects/#bitratepro");
}