(*
Copyright © 2006 Logan Rockmore

This script gets the count of unread messages from Mail.app

*)

set mailboxesWithUnreadMessages to {}

tell application "System Events" to if (application processes whose name is "Mail") is {} then return {{"", "", -1}}

tell application "Mail"
	
	-- get mailboxes with unread count
	set mailboxesWithUnreadMessages to mailboxes of accounts whose unread count is not 0
	set localMailboxesWithUnreadMessages to every mailbox whose unread count is not 0
	
	-- loop through all accounts and mailboxes
	set returnArray to {}
	repeat with currentAccount in mailboxesWithUnreadMessages & localMailboxesWithUnreadMessages
		repeat with currentMailbox in currentAccount
			
			-- get mailbox attributes
			set mailboxName to name of currentMailbox
			set mailboxCount to unread count of currentMailbox
			
			try
				set accountName to name of account of currentMailbox
			on error
				set accountName to ""
			end try
			
			-- create mailbox array
			set mailboxArray to {{mailboxName, accountName, mailboxCount}}
			
			-- append to overall array
			set returnArray to returnArray & mailboxArray
			
		end repeat
	end repeat
	
end tell

return returnArray
