function getLocalizedString(key){
try {
 var ret = localizedStrings[key];
 if (ret === undefined)
  ret = key;
  return ret;
 } catch (ex) {}
 return key;
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    document.getElementById("speedmode_text").innerHTML = getLocalizedString("SPEEDMODE");
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
// Stop any timers to prevent CPU usage
// Remove any preferences as needed
// widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
// Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    setSpeedMode();
    
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    setSpeedMode();
    
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function gotoxaddict(event)
{
    var websiteURL = "http://www.xaddict.info/";
    widget.openURL(websiteURL);
}


function donate(event)
{
    var websiteURL = "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=FJTKKY5DFVCSN";
    widget.openURL(websiteURL);
}

function mouseOutButton(event){
    
    var button = event.fromElement.parentNode.parentNode;
    var duration = 300;
    var fromFade = 1.0;
    var toFade = 0.7;
    var interval = 13;
    
    function fadeHandler(currentAnimator, current, start, finish){button.style.opacity = current;}
    
    fadeInAnimator = new AppleAnimator(duration, interval);
    fadeInAnim = new AppleAnimation(fromFade, toFade, fadeHandler);
    fadeInAnimator.addAnimation(fadeInAnim);
    fadeInAnimator.start();

}

function mouseOverButton(event){
    
    var button = event.toElement.parentNode.parentNode;
    var duration = 300;
    var fromFade = 0.7;
    var toFade = 1.0;
    var interval = 13;
    
    function fadeHandler(currentAnimator, current, start, finish){button.style.opacity = current;}
    
    fadeOutAnimator = new AppleAnimator(duration, interval);
    fadeOutAnim = new AppleAnimation(fromFade, toFade, fadeHandler);
    fadeOutAnimator.addAnimation(fadeOutAnim);
    fadeOutAnimator.start();

}


function removeFormatting(event)
{
    // Values you provide
    var button = document.getElementById("u_button");	// replace with name of element to fade
    var duration = 300;
    var busyText = getLocalizedString('BUSY');
    var finishedText = "unFormat";
    var minFade = 0.5;
    var maxFade = 1.0;
    var interval = 13;
    
    //fade function
    function fadeHandler(currentAnimator, current, start, finish){button.style.opacity = current;}
    
    fadeOutAnimator = new AppleAnimator(duration, interval);
    fadeOutAnim = new AppleAnimation(maxFade, minFade, fadeHandler);
    fadeOutAnimator.addAnimation(fadeOutAnim);

    fadeInAnimator = new AppleAnimator(duration, interval);
    fadeInAnim = new AppleAnimation(minFade, maxFade, fadeHandler);
    fadeInAnimator.addAnimation(fadeInAnim);

    fadeOutAnimator.start();
    button.object.setEnabled(false);
    button.object.textElement.innerText = busyText;
    button.style.color = "#aaa";
    fadeOutAnimator.oncomplete = function(){
        var checkboxValue = document.getElementById("speedmode").checked;
        //console.log("checkbox:"+checkboxValue);   
        
        if(!checkboxValue){
        widget.system("/usr/bin/osascript unformat_slowpoke.scpt", function(){fadeInAnimator.start();});
        } else {
        widget.system("/usr/bin/osascript unformat_speedmode.scpt", function(){fadeInAnimator.start();});
        }
    }
    fadeInAnimator.oncomplete = function(){
        button.style.color = "white";
        button.object.setEnabled(true);
        button.object.textElement.innerText = finishedText;
    }

}

function setSpeedMode(event)
{
    var thetext = document.getElementById("speedmode_text");
    var unformat_btn = document.getElementById("u_button");
    var checkboxValue = document.getElementById("speedmode").checked;
    if(checkboxValue){
       thetext.style.color = "white";
       thetext.style.textShadow = "rgb(255, 255, 255) 2px 0px 2px";
       unformat_btn.style.textShadow = "rgb(255, 255, 255) 0px 0px 5px";
       
    }else{
       thetext.style.color = "white";
       thetext.style.textShadow = "rgb(255, 255, 255) 0px 0px 0px";
       unformat_btn.style.textShadow = "rgb(255, 255, 255) 0px 0px 0px";
    }
}
